<?php
/*
  $Id: cm_header_shop_by_price.php
  $Loc: catalog/includes/modules/content/header/

  2019 Shop by Price 5.0 CE Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Based on:
  Contribution by Meltus  http://www.highbarn-consulting.com
  Adapted for OsCommerce MS2 by Sylvio Ruiz suporte@leilodata.com
  Modified by Hugues Deriau on 09/23/2006 - display the price ranges in the selected currency
  Modified by Glassraven for dropdown list 24/10/2006 www.glassraven.com
  Modified by -GuiGui- (http://www.gpuzin.com) - 07/03/2008 - fix the title and work with the contribution " Product Listing in Columns"

  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  class cm_header_shop_by_price {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_HEADER_SHOP_BY_PRICE_TITLE;
      $this->description = MODULE_CONTENT_HEADER_SHOP_BY_PRICE_DESCRIPTION;
      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';

      if ( defined('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_HEADER_SHOP_BY_PRICE_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_HEADER_SHOP_BY_PRICE_STATUS == 'True');
      }
    }

    function execute() {
      global $oscTemplate, $currencies, $currency, $request_type, $current_category_id;

      $content_width = (int)MODULE_CONTENT_HEADER_SHOP_BY_PRICE_CONTENT_WIDTH;

      $price_ranges = Array();

      $price_ranges_array = explode(',', constant('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_' . $currency));
      $price_ranges[0] =  MODULE_CONTENT_HEADER_SHOP_BY_PRICE_LESS_THAN .  $this->format0($price_ranges_array[0], false);
      for ($price_range=1; $price_range<sizeof($price_ranges_array); $price_range++) {
        $price_ranges[$price_range] = $this->format0($price_ranges_array[$price_range-1]). " &minus; " . $this->format0($price_ranges_array[$price_range]);
      }
      $price_ranges[sizeof($price_ranges_array)] =  MODULE_CONTENT_HEADER_SHOP_BY_PRICE_MORE_THAN .  $this->format0($price_ranges_array[sizeof($price_ranges_array)-1]);
      $price_ranges[sizeof($price_ranges_array)+1] =  MODULE_CONTENT_HEADER_SHOP_BY_PRICE_ALL;

      $price_range_list = null;
      $price_range_list[] = array('id' => '0', 'text' => PULL_DOWN_DEFAULT );

      for ($range=1; $range<sizeof($price_ranges)+1; $range++) {
        $price_range_list[] = array('id' => $range, 'text' => $price_ranges[$range-1] );
      }

      $range = null;
      if ( isset($_GET['range']) ) {
        $range = $_GET['range'];
      } elseif ( isset($_GET['lrange']) ) {
        $range = $_GET['lrange']+1;
      }

      ob_start();
      include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
      $template = ob_get_clean();

      $oscTemplate->addContent($template, $this->group);
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Shop by Price Module', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_STATUS', 'True', 'Do you want to add the module to your shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_CONTENT_WIDTH', '4', 'What width container should the content be shown in?', '6', '2', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_SORT_ORDER', '25', 'Sort order of display. Lowest is displayed first.', '6', '3', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use fast Tax Query', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_USE_FAST_TAX_QUERY', 'True', 'Should work for most shops with standard tax settings.<br>Set to false if you have very complicate tax sttings with several Tax zones/types and get missing products in range results.', '6', '4', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use decimal places', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_USE_DECIMAL', 'False', 'Do you want to use decimal places for the price ranges?', '6', '5', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      require_once('includes/classes/currencies.php');
      $currencies = new currencies();
      foreach($currencies->currencies as $key => $value) {
        tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Price Range " . $key . "', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_" . $key . "', '1,2,3,5,10', 'Price Range Steps separated by comma for " . $key . " currency.<br>Default:\"10,20,30,50,100\"<br>If decimals, use point for decimal separator. Example: 2.50', '6', '0', now())");
      }
   }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      require('includes/classes/currencies.php');
      $currencies = new currencies();
      $KeysArray = array('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_STATUS', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_CONTENT_WIDTH', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_SORT_ORDER',  'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_USE_FAST_TAX_QUERY', 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_USE_DECIMAL' );
      foreach($currencies->currencies as $key => $value) {
        array_push($KeysArray, 'MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_' . $key);
      }

      return $KeysArray;
    }

    function format0($number, $currency_type = '', $currency_value = '') {
      global $currencies, $currency, $calculate_currency_value;

      if (empty($currency_type)) $currency_type = $currency;

      if (MODULE_CONTENT_HEADER_SHOP_BY_PRICE_USE_DECIMAL == 'True') {
        if ($calculate_currency_value == true) {
          $rate = (tep_not_null($currency_value)) ? $currency_value : $currencies->currencies[$currency_type]['value'];
          $format_string = $currencies->currencies[$currency_type]['symbol_left'] . number_format(tep_round($number * $rate, $currencies->currencies[$currency_type]['decimal_places']), $currencies->currencies[$currency_type]['decimal_places'], $currencies->currencies[$currency_type]['decimal_point'], $currencies->currencies[$currency_type]['thousands_point']) . $currencies->currencies[$currency_type]['symbol_right'];
        } else {
          $format_string = $currencies->currencies[$currency_type]['symbol_left'] . number_format(tep_round($number, $currencies->currencies[$currency_type]['decimal_places']), $currencies->currencies[$currency_type]['decimal_places'], $currencies->currencies[$currency_type]['decimal_point'], $currencies->currencies[$currency_type]['thousands_point']) . $currencies->currencies[$currency_type]['symbol_right'];
        }
      } else {
        if ($calculate_currency_value == true) {
          $rate = (tep_not_null($currency_value)) ? $currency_value : $currencies->currencies[$currency_type]['value'];
          $format_string = $currencies->currencies[$currency_type]['symbol_left'] . number_format(tep_round(round($number * $rate, $round_places), $currencies->currencies[$currency_type]['decimal_places']), 0, $currencies->currencies[$currency_type]['decimal_point'], $currencies->currencies[$currency_type]['thousands_point']) . $currencies->currencies[$currency_type]['symbol_right'];
        } else {
          $format_string = $currencies->currencies[$currency_type]['symbol_left'] . number_format(tep_round($number, $currencies->currencies[$currency_type]['decimal_places']), 0, $currencies->currencies[$currency_type]['decimal_point'], $currencies->currencies[$currency_type]['thousands_point']) . $currencies->currencies[$currency_type]['symbol_right'];
        }
      }

      return $format_string;
    }
  }
