<?php
/*
  $Id: shop_by_price.php
  $Loc: catalog/

  2019 Shop by Price 5.0 CE Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Based on:
  Contribution by Meltus  http://www.highbarn-consulting.com
  Adapted for OsCommerce MS2 by Sylvio Ruiz suporte@leilodata.com
  Modified by Hugues Deriau on 09/23/2006 - display the price ranges in the selected currency
  Modified by Glassraven for dropdown list 24/10/2006 www.glassraven.com
  Modified by -GuiGui- (http://www.gpuzin.com) - 07/03/2008 - fix the title and work with the contribution " Product Listing in Columns"

  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  require('includes/application_top.php');

  require('includes/languages/' . $language . '/shop_by_price.php');

  $breadcrumb->add(NAVBAR_TITLE, tep_href_link('shop_by_price.php', tep_get_all_get_params(), 'NONSSL', true, false));

  require('includes/template_top.php');
  global $currency;

  $price_min = explode(',', defined('MODULE_BOXES_SHOP_BY_PRICE_STATUS')? constant('MODULE_BOXES_SHOP_BY_PRICE_PRICE_RANGE_' . $currency) : constant('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_' . $currency));
  array_unshift($price_min, 0);
  $price_max = explode(',', defined('MODULE_BOXES_SHOP_BY_PRICE_STATUS')? constant('MODULE_BOXES_SHOP_BY_PRICE_PRICE_RANGE_' . $currency) : constant('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_' . $currency));
  array_push($price_max, 0);

  // Initialize the varaible '$range' from param here because it's used in shop_by_price.php
  $range = null;
  if ( isset($_GET['range']) ) {
    $range = $_GET['range']-1;
  } elseif ( isset($_GET['lrange']) ) {
    $range = $_GET['lrange'];
  }

  $currencies_rate_query = tep_db_query("select value from currencies where code = '" . $currency . "'");
  $currency_rate = tep_db_fetch_array($currencies_rate_query);

  $pfrom = isset($price_min[$range]) ? $price_min[$range]/$currency_rate['value']  : 0;
  $pto   = isset($price_max[$range]) ? $price_max[$range]/$currency_rate['value']  : 0;

// create column list
  $define_list = array('PRODUCT_LIST_MODEL' => PRODUCT_LIST_MODEL,
                       'PRODUCT_LIST_NAME' => PRODUCT_LIST_NAME,
                       'PRODUCT_LIST_MANUFACTURER' => PRODUCT_LIST_MANUFACTURER,
                       'PRODUCT_LIST_PRICE' => PRODUCT_LIST_PRICE,
                       'PRODUCT_LIST_QUANTITY' => PRODUCT_LIST_QUANTITY,
                       'PRODUCT_LIST_WEIGHT' => PRODUCT_LIST_WEIGHT,
                       'PRODUCT_LIST_IMAGE' => PRODUCT_LIST_IMAGE,
                       'PRODUCT_LIST_BUY_NOW' => PRODUCT_LIST_BUY_NOW);

  asort($define_list);

  $column_list = array();
  foreach($define_list as $key => $value) {
    if ($value > 0) $column_list[] = $key;
  }

  $select_column_list = '';

  for ($i=0, $n=sizeof($column_list); $i<$n; $i++) {
    switch ($column_list[$i]) {
      case 'PRODUCT_LIST_MODEL':
        $select_column_list .= 'p.products_model, ';
        break;
      case 'PRODUCT_LIST_MANUFACTURER':
        $select_column_list .= 'm.manufacturers_name, ';
        break;
      case 'PRODUCT_LIST_QUANTITY':
        $select_column_list .= 'p.products_quantity, ';
        break;
      case 'PRODUCT_LIST_IMAGE':
        $select_column_list .= 'p.products_image, ';
        break;
      case 'PRODUCT_LIST_WEIGHT':
        $select_column_list .= 'p.products_weight, ';
        break;
    }
  }

  $select_str = "select distinct " . $select_column_list . "  p.products_id, pd.products_name, pd.products_description, p.manufacturers_id, p.products_date_added, p.products_price, p.products_tax_class_id, IF(s.status, s.specials_new_products_price, NULL) as specials_new_products_price, IF(s.status, s.specials_new_products_price, p.products_price) as final_price, p.products_quantity as in_stock, if(s.status, 1, 0) as is_special  ";

  if ( (DISPLAY_PRICE_WITH_TAX == 'true') && (tep_not_null($pfrom) || tep_not_null($pto)) ) {
    $select_str .= ", SUM(tr.tax_rate) as tax_rate ";
  }

  $from_str = "from products p left join manufacturers m using(manufacturers_id) left join specials s on p.products_id = s.products_id";

  if ( (DISPLAY_PRICE_WITH_TAX == 'true') && (tep_not_null($pfrom) || tep_not_null($pto)) ) {
    if (!tep_session_is_registered('customer_country_id')) {
      $customer_country_id = STORE_COUNTRY;
      $customer_zone_id = STORE_ZONE;
    }
    if(MODULE_CONTENT_HEADER_SHOP_BY_PRICE_USE_FAST_TAX_QUERY == 'True') {
      $from_str .= " left join tax_rates tr on p.products_tax_class_id = tr.tax_class_id inner join zones_to_geo_zones gz on tr.tax_zone_id = gz.geo_zone_id and (gz.zone_country_id is null or gz.zone_country_id = '0' or gz.zone_country_id = '" . (int)$customer_country_id . "') and (gz.zone_id is null or gz.zone_id = '0' or gz.zone_id = '" . (int)$customer_zone_id . "')";
    } else {
      $from_str .= " left join tax_rates tr on p.products_tax_class_id = tr.tax_class_id left join zones_to_geo_zones gz on tr.tax_zone_id = gz.geo_zone_id and (gz.zone_country_id is null or gz.zone_country_id = '0' or gz.zone_country_id = '" . (int)$customer_country_id . "') and (gz.zone_id is null or gz.zone_id = '0' or gz.zone_id = '" . (int)$customer_zone_id . "')";
    }
  }

  if (isset($_GET['cPath']) && tep_not_null($_GET['cPath'])) {
    $from_str .= ", products_description pd, categories c, products_to_categories p2c";
    $where_str = " where p.products_status = '1' and p.products_id = pd.products_id and pd.language_id = '" . (int)$languages_id . "' and p.products_id = p2c.products_id and p2c.categories_id = c.categories_id ";

    $subcategories_array = array();
    tep_get_subcategories($subcategories_array, $_GET['cPath']);

      $where_str .= " and p2c.products_id = p.products_id and p2c.products_id = pd.products_id and (p2c.categories_id = '" . (int)$_GET['cPath'] . "'";

      for ($i=0, $n=sizeof($subcategories_array); $i<$n; $i++ ) {
        $where_str .= " or p2c.categories_id = '" . (int)$subcategories_array[$i] . "'";
      }

      $where_str .= ")";
  } else {
    $from_str .= ", products_description pd";
    $where_str = " where p.products_status = '1' and p.products_id = pd.products_id and pd.language_id = '" . (int)$languages_id . "'";
  }

  if (isset($_GET['manufacturers_id']) && tep_not_null($_GET['manufacturers_id'])) {
    $where_str .= " and m.manufacturers_id = '" . (int)$_GET['manufacturers_id'] . "'";
  }

  if (DISPLAY_PRICE_WITH_TAX == 'true') {
    if ($pfrom > 0) $where_str .= " and (IF(s.status, s.specials_new_products_price, p.products_price) * if(gz.geo_zone_id is null, 1, 1 + (tr.tax_rate / 100) ) >= " . (double)$pfrom . ")";
    if ($pto > 0) $where_str .= " and (IF(s.status, s.specials_new_products_price, p.products_price) * if(gz.geo_zone_id is null, 1, 1 + (tr.tax_rate / 100) ) <= " . (double)$pto . ")";
  } else {
    if ($pfrom > 0) $where_str .= " and (IF(s.status, s.specials_new_products_price, p.products_price) >= " . (double)$pfrom . ")";
    if ($pto > 0) $where_str .= " and (IF(s.status, s.specials_new_products_price, p.products_price) <= " . (double)$pto . ")";
  }

  if ( (DISPLAY_PRICE_WITH_TAX == 'true') && (tep_not_null($pfrom) || tep_not_null($pto)) ) {
    $where_str .= " group by p.products_id, tr.tax_priority";
  }

  if ( (!isset($_GET['sort'])) || (!preg_match('/[1-8][ad]/', $_GET['sort'])) || (substr($_GET['sort'], 0, 1) > sizeof($column_list)) ) {
    for ($i=0, $n=sizeof($column_list); $i<$n; $i++) {
      if ($column_list[$i] == 'PRODUCT_LIST_PRICE') {
        $_GET['sort'] = $i+1 . 'a';
        $order_str = ' order by final_price, pd.products_name';
        break;
      }
    }
  } else {
    $sort_col = substr($_GET['sort'], 0 , 1);
    $sort_order = substr($_GET['sort'], 1);
    $order_str = ' order by ';
    switch ($column_list[$sort_col-1]) {
      case 'PRODUCT_LIST_MODEL':
        $order_str .= "p.products_model " . ($sort_order == 'd' ? "desc" : "") . ", pd.products_name";
        break;
      case 'PRODUCT_LIST_NAME':
        $order_str .= "pd.products_name " . ($sort_order == 'd' ? "desc" : "");
        break;
      case 'PRODUCT_LIST_MANUFACTURER':
        $order_str .= "m.manufacturers_name " . ($sort_order == 'd' ? "desc" : "") . ", pd.products_name";
        break;
      case 'PRODUCT_LIST_QUANTITY':
        $order_str .= "p.products_quantity " . ($sort_order == 'd' ? "desc" : "") . ", pd.products_name";
        break;
      case 'PRODUCT_LIST_IMAGE':
        $order_str .= "pd.products_name";
        break;
      case 'PRODUCT_LIST_WEIGHT':
        $order_str .= "p.products_weight " . ($sort_order == 'd' ? "desc" : "") . ", pd.products_name";
        break;
      case 'PRODUCT_LIST_PRICE':
        $order_str .= "final_price " . ($sort_order == 'd' ? "desc" : "") . ", pd.products_name";
        break;
    }
  }

  $listing_sql = $select_str . $from_str . $where_str . $order_str;

  if (class_exists('cm_header_shop_by_price')) {
    $shop_by_price_format = new cm_header_shop_by_price();
  } else if (class_exists('bm_shop_by_price')) {
    $shop_by_price_format = new bm_shop_by_price();
  }

  $price_ranges = Array();
  $price_ranges_array = explode(',', defined('MODULE_BOXES_SHOP_BY_PRICE_STATUS')? constant('MODULE_BOXES_SHOP_BY_PRICE_PRICE_RANGE_' . $currency) : constant('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_' . $currency));
  $price_ranges[0] =  TEXT_SHOP_BY_PRICE_LESS_THAN .  $shop_by_price_format->format0($price_ranges_array[0]);
  for ($price_range=1; $price_range<sizeof($price_ranges_array); $price_range++) {
    $price_ranges[$price_range] = $shop_by_price_format->format0($price_ranges_array[$price_range-1]) . " &minus; " . $shop_by_price_format->format0($price_ranges_array[$price_range]);
  }
  $price_ranges[sizeof($price_ranges_array)] =  TEXT_SHOP_BY_PRICE_MORE_THAN .  $shop_by_price_format->format0($price_ranges_array[sizeof($price_ranges_array)-1]);
  $price_ranges[sizeof($price_ranges_array)+1] =  TEXT_SHOP_BY_PRICE_ALL;

  if ( isset($_GET['cPath']) )
    $category_name = implode(',', tep_db_fetch_array(tep_db_query("select categories_name from categories_description where categories_id = '" . (int)$_GET['cPath'] . "' and language_id = '" . (int)$languages_id . "'")));

  if ( isset($_GET['manufacturers_id']) )
    $manufacturer_name = implode(',', tep_db_fetch_array(tep_db_query("select manufacturers_name from manufacturers where manufacturers_id = '" . (int)$_GET['manufacturers_id'] . "'")));

?>
<div class="page-header">
  <h1><?php echo ( !isset($range)? HEADING_TITLE_1 : HEADING_TITLE_PRODUCTS . (isset($_GET['cPath'])? HEADING_TITLE_CATEGORY . $category_name . '<br />': '') . (isset($_GET['manufacturers_id'])? HEADING_TITLE_MANUFACTURER . $manufacturer_name  . '<br />': '') . ( ($range == sizeof($price_ranges_array)+1) ? HEADING_TITLE_WITH : HEADING_TITLE_PRICE ) . $price_ranges[$range] ); ?></h1>
</div>

<?php
  include('includes/modules/product_listing.php');

  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
 ?>